Index: /palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 3743)
+++ /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 3744)
@@ -995,10 +1104,10 @@
 !--          with heat capacity of air 0.33 Wh/m2K
              h_ve   = MAX( 0.01_wp , ( air_change * indoor_volume_per_facade *      &
-                                    0.33_wp * (1 - eta_ve ) ) )    !< [W/K] from ISO 13789 Eq.(10)
+                                    0.33_wp * (1.0_wp - buildings(nb)%eta_ve ) ) )    !< [W/K] from ISO 13789 Eq.(10)
 
 !--          Heat transfer coefficient auxiliary variables
-             h_tr_1 = 1 / ( ( 1 / h_ve )   + ( 1 / h_tr_is ) )  !< [W/K] Eq. (C.6)
+             h_tr_1 = 1.0_wp / ( ( 1.0_wp / h_ve )   + ( 1.0_wp / h_tr_is ) )  !< [W/K] Eq. (C.6)
              h_tr_2 = h_tr_1 + h_tr_w                           !< [W/K] Eq. (C.7)
-             h_tr_3 = 1 / ( ( 1 / h_tr_2 ) + ( 1 / h_tr_ms ) )  !< [W/K] Eq. (C.8)
+             h_tr_3 = 1.0_wp / ( ( 1.0_wp / h_tr_2 ) + ( 1.0_wp / h_tr_ms ) )  !< [W/K] Eq. (C.8)
 !
 !--          Net short-wave radiation through window area (was i_global)
@@ -1028,6 +1137,6 @@
 !--          DIN 4108 - 2 chap.8
              phi_sol = (   window_area_per_facade * net_sw_in * solar_protection_off               &
-                         + window_area_per_facade * net_sw_in * f_c_win * solar_protection_on )    &
-                       * g_value_win * ( 1 - params_f_f ) * params_f_w              !< [W]
+                         + window_area_per_facade * net_sw_in * buildings(nb)%f_c_win * solar_protection_on )    &
+                       * buildings(nb)%g_value_win * ( 1.0_wp - params_f_f ) * params_f_w              !< [W]
 !
 !--          Calculation of the mass specific thermal load for internal and external heatsources of the inner node
@@ -1035,5 +1144,5 @@
 !
 !--          Calculation mass specific thermal load implied non thermal mass 
-             phi_st  =   ( 1 - ( eff_mass_area / total_area ) - ( h_tr_w / ( 9.1 * total_area ) ) ) &
+             phi_st  =   ( 1.0_wp - ( eff_mass_area / total_area ) - ( h_tr_w / ( 9.1_wp * total_area ) ) ) &
                        * ( phi_ia + phi_sol )                                       !< [W] Eq. (C.3) with phi_ia=0,5*phi_int
 !
@@ -1041,5 +1150,5 @@
 !--          Step 1: Indoor temperature without heating and cooling
 !--          section C.4.1 Picture C.2 zone 3)
-             phi_hc_nd = 0
+             phi_hc_nd = 0.0_wp
              
              CALL im_calc_temperatures ( i, j, k, indoor_wall_window_temperature, &
@@ -1047,10 +1156,10 @@
 !
 !--          If air temperature between border temperatures of heating and cooling, assign output variable, then ready   
-             IF ( theta_int_h_set <= theta_air  .AND.  theta_air <= theta_int_c_set )  THEN
-                phi_hc_nd_ac = 0
+             IF ( buildings(nb)%theta_int_h_set <= theta_air  .AND.  theta_air <= buildings(nb)%theta_int_c_set )  THEN
+                phi_hc_nd_ac = 0.0_wp
                 phi_hc_nd    = phi_hc_nd_ac
                 theta_air_ac = theta_air
 !
-!--          Step 2: Else, apply 10 W/mÂ² heating/cooling power and calculate indoor temperature
+!--          Step 2: Else, apply 10 W/m2 heating/cooling power and calculate indoor temperature
 !--          again.
              ELSE
@@ -1060,8 +1169,8 @@
 
 !--             Heating or cooling?
-                IF ( theta_air > theta_int_c_set )  THEN
-                   theta_air_set = theta_int_c_set
+                IF ( theta_air > buildings(nb)%theta_int_c_set )  THEN
+                   theta_air_set = buildings(nb)%theta_int_c_set
                 ELSE 
-                   theta_air_set = theta_int_h_set 
+                   theta_air_set = buildings(nb)%theta_int_h_set 
                 ENDIF
 
@@ -1079,10 +1188,8 @@
                                             / (theta_air_10  - theta_air_0)            !< Eq. (C.13)
                                             
-                                            
-                                        
 !--             Step 3: With temperature ratio to determine the heating or cooling capacity    
 !--             If necessary, limit the power to maximum power
 !--             section C.4.1 Picture C.2 zone 2) and 4)
-                IF ( phi_c_max < phi_hc_nd_un  .AND.  phi_hc_nd_un < phi_h_max )  THEN
+                IF ( buildings(nb)%phi_c_max < phi_hc_nd_un  .AND.  phi_hc_nd_un < buildings(nb)%phi_h_max )  THEN
                    phi_hc_nd_ac = phi_hc_nd_un
                    phi_hc_nd = phi_hc_nd_un    
@@ -1090,8 +1197,8 @@
 !--             Step 4: Inner temperature with maximum heating (phi_hc_nd_un positive) or cooling (phi_hc_nd_un negative)
 !--             section C.4.1 Picture C.2 zone 1) and 5)
-                   IF ( phi_hc_nd_un > 0 )  THEN
-                      phi_hc_nd_ac = phi_h_max                                         !< Limit heating
+                   IF ( phi_hc_nd_un > 0.0_wp )  THEN
+                      phi_hc_nd_ac = buildings(nb)%phi_h_max                                         !< Limit heating
                    ELSE 
-                      phi_hc_nd_ac = phi_c_max                                         !< Limit cooling
+                      phi_hc_nd_ac = buildings(nb)%phi_c_max                                         !< Limit cooling
                    ENDIF
                 ENDIF
@@ -1112,5 +1219,5 @@
 !--          Calculate the operating temperature with weighted mean temperature of air and mean solar temperature
 !--          Will be used for thermal comfort calculations 
-             theta_op     = 0.3 * theta_air_ac + 0.7 * theta_s          !< [degree_C] operative Temperature Eq. (C.12)
+             theta_op     = 0.3_wp * theta_air_ac + 0.7_wp * theta_s          !< [degree_C] operative Temperature Eq. (C.12)
 !
 !--          Heat flux into the wall. Value needed in urban_surface_mod to 
@@ -1132,14 +1239,14 @@
 !--          Calculation of waste heat
 !--          Anthropogenic heat output
-              IF ( phi_hc_nd_ac > 0 )  THEN 
-                   heating_on = 1
-                   cooling_on = 0
-              ELSE 
-                   heating_on = 0
-                   cooling_on = 1
-              ENDIF
-
-             q_waste_heat = (phi_hc_nd * (params_waste_heat_h * heating_on + params_waste_heat_c * cooling_on))  !< [W/m2]  anthropogenic heat output
-!              surf_usm_h%shf(m)=q_waste_heat
+             IF ( phi_hc_nd_ac > 0.0_wp )  THEN 
+                heating_on = 1
+                cooling_on = 0
+             ELSE 
+                heating_on = 0
+                cooling_on = 1
+             ENDIF
+
+             q_waste_heat = (phi_hc_nd * (params_waste_heat_h * heating_on + params_waste_heat_c * cooling_on))!< [W/GebÃ€udemodell] , observe the directional convention in PALM!
+             surf_usm_h%waste_heat(m) = q_waste_heat
              
           ENDDO !< Horizontal surfaces loop
@@ -1156,4 +1263,6 @@
              kk = surf_usm_v(l)%k(m) + surf_usm_v(l)%koff
 !
+!--          (SOME OF THE FOLLOWING (not time-dependent COULD PROBABLY GO INTO A FUNCTION
+!--          EXCEPT facade_element_area, EVERYTHING IS CALCULATED EQUALLY)
 !--          Building geometries  --> not time-dependent
              IF ( l == 0  .OR. l == 1 ) facade_element_area = dx * dzw(kk)  !< [m2] surface area per facade element
@@ -1162,24 +1271,29 @@
              indoor_volume_per_facade = buildings(nb)%vpf(kk)               !< [m3] indoor air volume per facade element           
              window_area_per_facade   = surf_usm_v(l)%frac(ind_wat_win,m)  * facade_element_area  !< [m2] window area per facade element
-             eff_mass_area            = factor_a * floor_area_per_facade    !< [m2] standard values according to Table 12 section 12.3.1.2  (calculate over Eq. (65) according to section 12.3.1.2)
-             c_m                      = factor_c * floor_area_per_facade    !< [J/K] standard values according to table 12 section 12.3.1.2 (calculate over Eq. (66) according to section 12.3.1.2)
-             total_area               = lambda_at * floor_area_per_facade   !< [m2] area of all surfaces pointing to zone Eq. (9) according to section 7.2.2.2
+             
+             building_height          = buildings(nb)%kb_max * dzw(kk)
+             f_cei                    = building_height/(buildings(nb)%height_storey-buildings(nb)%height_cei_con) !< [-] factor for ceiling redcution
+             ngs                      = buildings(nb)%vpf(kk)/f_cei                    !< [m2] calculation of netto ground surface
+             f_sr                     = ngs/floor_area_per_facade                      !< [-] factor for surface reduction
+             eff_mass_area            = buildings(nb)%factor_a * ngs    !< [m2] standard values according to Table 12 section 12.3.1.2  (calculate over Eq. (65) according to section 12.3.1.2)
+             c_m                      = buildings(nb)%factor_c * ngs    !< [J/K] standard values according to table 12 section 12.3.1.2 (calculate over Eq. (66) according to section 12.3.1.2)
+             total_area               = buildings(nb)%lambda_at * floor_area_per_facade   !< [m2] area of all surfaces pointing to zone  Eq. (9) according to section 7.2.2.2
 !
 !--          Calculation of heat transfer coefficient for transmission --> not time-dependent
-             h_tr_w   = window_area_per_facade * u_value_win   !< [W/K] only for windows
+             h_tr_w   = window_area_per_facade * buildings(nb)%u_value_win   !< [W/K] only for windows
              h_tr_is  = total_area * h_is                      !< [W/K] with h_is = 3.45 W / (m2 K) between surface and air, Eq. (9)
              h_tr_ms  = eff_mass_area * h_ms                   !< [W/K] with h_ms = 9.10 W / (m2 K) between component and surface, Eq. (64)
-             h_tr_op  = 1 / ( 1 / ( ( facade_element_area - window_area_per_facade ) &
-                                    * lambda_layer3 / s_layer3 * 0.5 ) + 1 / h_tr_ms )
-             h_tr_em  = 1 / ( 1 / h_tr_op - 1 / h_tr_ms )      !< [W/K] Eq. (63), Section 12.2.2
+             h_tr_op  = 1.0_wp / ( 1.0_wp / ( ( facade_element_area - window_area_per_facade ) &
+                                    * buildings(nb)%lambda_layer3 / buildings(nb)%s_layer3 * 0.5_wp ) + 1.0_wp / h_tr_ms )
+             h_tr_em  = 1.0_wp / ( 1.0_wp / h_tr_op - 1.0_wp / h_tr_ms )      !< [W/K] Eq. (63), Section 12.2.2
 !
 !--          internal air loads dependent on the occupacy of the room
 !--          basical internal heat gains (qint_low) with additional internal heat gains by occupancy (qint_high) (0,5*phi_int)
-             phi_ia = 0.5 * ( ( qint_high * schedule_d + qint_low )            &
-                              * floor_area_per_facade )                      !< [W] Eq. (C.1)
+             phi_ia = 0.5_wp * ( ( buildings(nb)%qint_high * schedule_d + buildings(nb)%qint_low )            &
+                              * ngs )                      !< [W] Eq. (C.1)
 !
 !--          Airflow dependent on the occupacy of the room
 !--          basical airflow (air_change_low) with additional airflow gains by occupancy (air_change_high)
-             air_change = ( air_change_high * schedule_d + air_change_low )  
+             air_change = ( buildings(nb)%air_change_high * schedule_d + buildings(nb)%air_change_low )  
 !
 !--          Heat transfer of ventilation 
@@ -1187,10 +1301,10 @@
 !--          with heat capacity of air 0.33 Wh/m2K
              h_ve   = MAX( 0.01_wp , ( air_change * indoor_volume_per_facade *      &
-                                    0.33_wp * (1 - eta_ve ) ) )                    !< [W/K] from ISO 13789 Eq.(10)
+                                    0.33_wp * (1 - buildings(nb)%eta_ve ) ) )                    !< [W/K] from ISO 13789 Eq.(10)
                                     
 !--          Heat transfer coefficient auxiliary variables
-             h_tr_1 = 1 / ( ( 1 / h_ve )   + ( 1 / h_tr_is ) )                  !< [W/K] Eq. (C.6)
+             h_tr_1 = 1.0_wp / ( ( 1.0_wp / h_ve )   + ( 1.0_wp / h_tr_is ) )                  !< [W/K] Eq. (C.6)
              h_tr_2 = h_tr_1 + h_tr_w                                           !< [W/K] Eq. (C.7)
-             h_tr_3 = 1 / ( ( 1 / h_tr_2 ) + ( 1 / h_tr_ms ) )                  !< [W/K] Eq. (C.8)
+             h_tr_3 = 1.0_wp / ( ( 1.0_wp / h_tr_2 ) + ( 1.0_wp / h_tr_ms ) )                  !< [W/K] Eq. (C.8)
 !
 !--          Net short-wave radiation through window area (was i_global)
@@ -1220,6 +1334,6 @@
 !--          DIN 4108 - 2 chap.8
              phi_sol = (   window_area_per_facade * net_sw_in * solar_protection_off               &
-                         + window_area_per_facade * net_sw_in * f_c_win * solar_protection_on )    &
-                       * g_value_win * ( 1 - params_f_f ) * params_f_w
+                         + window_area_per_facade * net_sw_in * buildings(nb)%f_c_win * solar_protection_on )    &
+                       * buildings(nb)%g_value_win * ( 1.0_wp - params_f_f ) * params_f_w
 !
 !--          Calculation of the mass specific thermal load for internal and external heatsources
@@ -1227,5 +1341,5 @@
 !
 !--          Calculation mass specific thermal load implied non thermal mass 
-             phi_st  =   ( 1 - ( eff_mass_area / total_area ) - ( h_tr_w / ( 9.1 * total_area ) ) ) &
+             phi_st  =   ( 1.0_wp - ( eff_mass_area / total_area ) - ( h_tr_w / ( 9.1_wp * total_area ) ) ) &
                        * ( phi_ia + phi_sol )                                       !< [W] Eq. (C.3) with phi_ia=0,5*phi_int
 !
@@ -1233,16 +1347,15 @@
 !--          Step 1: Indoor temperature without heating and cooling
 !--          section C.4.1 Picture C.2 zone 3)
-             phi_hc_nd = 0
-             
+             phi_hc_nd = 0.0_wp
              CALL im_calc_temperatures ( i, j, k, indoor_wall_window_temperature, &
                                          near_facade_temperature, phi_hc_nd )
 !
 !--          If air temperature between border temperatures of heating and cooling, assign output variable, then ready  
-             IF ( theta_int_h_set <= theta_air  .AND.  theta_air <= theta_int_c_set )  THEN
-                phi_hc_nd_ac = 0
+             IF ( buildings(nb)%theta_int_h_set <= theta_air  .AND.  theta_air <= buildings(nb)%theta_int_c_set )  THEN
+                phi_hc_nd_ac = 0.0_wp
                 phi_hc_nd    = phi_hc_nd_ac
                 theta_air_ac = theta_air
 !
-!--          Step 2: Else, apply 10 W/mÂ² heating/cooling power and calculate indoor temperature
+!--          Step 2: Else, apply 10 W/m2 heating/cooling power and calculate indoor temperature
 !--          again.
              ELSE
@@ -1252,8 +1365,8 @@
 
 !--             Heating or cooling?
-                IF ( theta_air > theta_int_c_set )  THEN
-                   theta_air_set = theta_int_c_set
+                IF ( theta_air > buildings(nb)%theta_int_c_set )  THEN
+                   theta_air_set = buildings(nb)%theta_int_c_set
                 ELSE 
-                   theta_air_set = theta_int_h_set 
+                   theta_air_set = buildings(nb)%theta_int_h_set 
                 ENDIF
 
@@ -1274,5 +1387,5 @@
 !--             If necessary, limit the power to maximum power
 !--             section C.4.1 Picture C.2 zone 2) and 4)
-                IF ( phi_c_max < phi_hc_nd_un  .AND.  phi_hc_nd_un < phi_h_max )  THEN
+                IF ( buildings(nb)%phi_c_max < phi_hc_nd_un  .AND.  phi_hc_nd_un < buildings(nb)%phi_h_max )  THEN
                    phi_hc_nd_ac = phi_hc_nd_un
                    phi_hc_nd = phi_hc_nd_un
@@ -1280,8 +1393,8 @@
 !--             Step 4: Inner temperature with maximum heating (phi_hc_nd_un positive) or cooling (phi_hc_nd_un negative)
 !--             section C.4.1 Picture C.2 zone 1) and 5)
-                   IF ( phi_hc_nd_un > 0 )  THEN
-                      phi_hc_nd_ac = phi_h_max                                         !< Limit heating
+                   IF ( phi_hc_nd_un > 0.0_wp )  THEN
+                      phi_hc_nd_ac = buildings(nb)%phi_h_max                                         !< Limit heating
                    ELSE 
-                      phi_hc_nd_ac = phi_c_max                                         !< Limit cooling
+                      phi_hc_nd_ac = buildings(nb)%phi_c_max                                         !< Limit cooling
                    ENDIF
                 ENDIF
@@ -1302,5 +1415,5 @@
 !--          Calculate the operating temperature with weighted mean of temperature of air and mean
 !--          Will be used for thermal comfort calculations 
-             theta_op     = 0.3 * theta_air_ac + 0.7 * theta_s
+             theta_op     = 0.3_wp * theta_air_ac + 0.7_wp * theta_s
 !
 !--          Heat flux into the wall. Value needed in urban_surface_mod to 
@@ -1322,15 +1435,15 @@
 !--          Calculation of waste heat
 !--          Anthropogenic heat output
-              IF ( phi_hc_nd_ac > 0 )  THEN 
-                   heating_on = 1
-                   cooling_on = 0
-              ELSE 
-                   heating_on = 0
-                   cooling_on = 1
-              ENDIF
-
-             q_waste_heat = (phi_hc_nd * (params_waste_heat_h * heating_on + params_waste_heat_c * cooling_on))   !< [W/m2] , anthropogenic heat output
-!              surf_usm_v(l)%waste_heat(m)=q_waste_heat
-             
+             IF ( phi_hc_nd_ac > 0.0_wp )  THEN 
+                heating_on = 1
+                cooling_on = 0
+             ELSE 
+                heating_on = 0
+                cooling_on = 1
+             ENDIF
+
+             q_waste_heat = (phi_hc_nd * (params_waste_heat_h * heating_on + params_waste_heat_c * cooling_on))!< [W/GebÃ€udemodell] , observe the directional convention in PALM!
+             surf_usm_v(l)%waste_heat(m) = q_waste_heat
+
           ENDDO !< Vertical surfaces loop
 
@@ -1339,6 +1452,5 @@
 
 !
-!-- Determine total number of facade elements per building and assign number to 
-!-- building data type.
+!-- Determine the mean building temperature. 
     DO  nb = 1, num_build
 !
@@ -1383,4 +1495,216 @@
  END SUBROUTINE im_main_heatcool
 
+!-----------------------------------------------------------------------------!
+! Description:
+!-------------
+!> Check data output for plant canopy model
+!-----------------------------------------------------------------------------! 
+ SUBROUTINE im_check_data_output( var, unit )
+        
+    IMPLICIT NONE
+    
+    CHARACTER (LEN=*) ::  unit   !<
+    CHARACTER (LEN=*) ::  var    !<
+        
+    SELECT CASE ( TRIM( var ) )
+    
+    
+        CASE ( 'im_hf_roof')
+           unit = 'W m-2'
+        
+        CASE ( 'im_hf_wall_win' )
+           unit = 'W m-2'
+           
+        CASE ( 'im_hf_wall_win_waste' )
+           unit = 'W m-2'
+           
+        CASE ( 'im_hf_roof_waste' )
+           unit = 'W m-2'
+        
+        CASE ( 'im_t_indoor' )
+           unit = 'K'
+        
+        CASE DEFAULT
+           unit = 'illegal'
+           
+    END SELECT
+    
+ END SUBROUTINE
+
+
+!-----------------------------------------------------------------------------!
+! Description:
+!-------------
+!> Check parameters routine for plant canopy model
+!-----------------------------------------------------------------------------! 
+ SUBROUTINE im_check_parameters
+
+!!!!   USE control_parameters,
+!!!!       ONLY: message_string
+       
+   IMPLICIT NONE
+   
+ END SUBROUTINE im_check_parameters
+
+!-----------------------------------------------------------------------------!
+! Description:
+!-------------
+!> Subroutine defining appropriate grid for netcdf variables.
+!> It is called from subroutine netcdf.
+!-----------------------------------------------------------------------------! 
+ SUBROUTINE im_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
+
+   IMPLICIT NONE
+   
+   CHARACTER (LEN=*), INTENT(IN)  ::  var
+   LOGICAL, INTENT(OUT)           ::  found
+   CHARACTER (LEN=*), INTENT(OUT) ::  grid_x
+   CHARACTER (LEN=*), INTENT(OUT) ::  grid_y
+   CHARACTER (LEN=*), INTENT(OUT) ::  grid_z
+   
+   found   = .TRUE.
+   
+!
+!-- Check for the grid
+    SELECT CASE ( TRIM( var ) )
+
+       CASE ( 'im_hf_roof', 'im_hf_roof_waste' )
+          grid_x = 'x'
+          grid_y = 'y'
+          grid_z = 'zw'
+!
+!--    Heat fluxes at vertical walls are actually defined on stagged grid, i.e. xu, yv.
+       CASE ( 'im_hf_wall_win', 'im_hf_wall_win_waste' )
+          grid_x = 'x'
+          grid_y = 'y'
+          grid_z = 'zu'
+          
+       CASE ( 'im_t_indoor' )
+          grid_x = 'x'
+          grid_y = 'y'
+          grid_z = 'zw'
+          
+       CASE DEFAULT
+          found  = .FALSE.
+          grid_x = 'none'
+          grid_y = 'none'
+          grid_z = 'none'
+    END SELECT
+    
+ END SUBROUTINE im_define_netcdf_grid
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Subroutine defining 3D output variables
+!------------------------------------------------------------------------------!
+ SUBROUTINE im_data_output_3d( av, variable, found, local_pf, fill_value,      &
+                               nzb_do, nzt_do )
+
+   USE indices
+   
+   USE kinds
+          
+   IMPLICIT NONE
+   
+    CHARACTER (LEN=*) ::  variable !< 
+
+    INTEGER(iwp) ::  av    !< 
+    INTEGER(iwp) ::  i     !< 
+    INTEGER(iwp) ::  j     !< 
+    INTEGER(iwp) ::  k     !< 
+    INTEGER(iwp) ::  l     !<
+    INTEGER(iwp) ::  m     !< 
+    INTEGER(iwp) ::  nb    !< index of the building in the building data structure 
+    INTEGER(iwp) ::  nzb_do !< lower limit of the data output (usually 0)
+    INTEGER(iwp) ::  nzt_do !< vertical upper limit of the data output (usually nz_do3d)
+
+    
+    LOGICAL      ::  found !< 
+
+    REAL(wp), INTENT(IN) ::  fill_value !< value for the _FillValue attribute
+
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !< 
+    
+    local_pf = fill_value
+    
+    found = .TRUE.
+    
+    SELECT CASE ( TRIM( variable ) )
+!
+!--     Output of indoor temperature. All grid points within the building are
+!--     filled with values, while atmospheric grid points are set to _FillValues.
+        CASE ( 'im_t_indoor' )
+           IF ( av == 0 ) THEN
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
+!
+!--                    Determine index of the building within the building data structure. 
+                       nb = MINLOC( ABS( buildings(:)%id - building_id_f%var(j,i) ),   &
+                                    DIM = 1 )
+!
+!--                    Write mean building temperature onto output array. Please note,
+!--                    in contrast to many other loops in the output, the vertical 
+!--                    bounds are determined by the lowest and hightest vertical index
+!--                    occupied by the building. 
+                       DO  k = buildings(nb)%kb_min, buildings(nb)%kb_max
+                          local_pf(i,j,k) = buildings(nb)%t_in(k)
+                       ENDDO
+                    ENDIF
+                 ENDDO
+              ENDDO
+           ENDIF  
+
+        CASE ( 'im_hf_roof' )
+           IF ( av == 0 ) THEN
+              DO  m = 1, surf_usm_h%ns
+                  i = surf_usm_h%i(m) !+ surf_usm_h%ioff
+                  j = surf_usm_h%j(m) !+ surf_usm_h%joff
+                  k = surf_usm_h%k(m) !+ surf_usm_h%koff
+                  local_pf(i,j,k) = surf_usm_h%iwghf_eb(m)
+              ENDDO
+           ENDIF 
+    
+        CASE ( 'im_hf_roof_waste' )
+           IF ( av == 0 ) THEN
+              DO m = 1, surf_usm_h%ns 
+                 i = surf_usm_h%i(m) !+ surf_usm_h%ioff
+                 j = surf_usm_h%j(m) !+ surf_usm_h%joff
+                 k = surf_usm_h%k(m) !+ surf_usm_h%koff
+                 local_pf(i,j,k) = surf_usm_h%waste_heat(m)
+              ENDDO
+           ENDIF                     
+       
+       CASE ( 'im_hf_wall_win' )
+           IF ( av == 0 ) THEN
+              DO l = 0, 3
+                 DO m = 1, surf_usm_v(l)%ns
+                    i = surf_usm_v(l)%i(m) !+ surf_usm_v(l)%ioff
+                    j = surf_usm_v(l)%j(m) !+ surf_usm_v(l)%joff
+                    k = surf_usm_v(l)%k(m) !+ surf_usm_v(l)%koff
+                    local_pf(i,j,k) = surf_usm_v(l)%iwghf_eb(m)
+                 ENDDO
+              ENDDO
+           ENDIF
+           
+        CASE ( 'im_hf_wall_win_waste' )
+           IF ( av == 0 ) THEN
+              DO l = 0, 3
+                 DO m = 1, surf_usm_v(l)%ns 
+                    i = surf_usm_v(l)%i(m) !+ surf_usm_v(l)%ioff
+                    j = surf_usm_v(l)%j(m) !+ surf_usm_v(l)%joff
+                    k = surf_usm_v(l)%k(m) !+ surf_usm_v(l)%koff
+                    local_pf(i,j,k) =  surf_usm_v(l)%waste_heat(m) 
+                 ENDDO
+              ENDDO
+           ENDIF      
+    
+        CASE DEFAULT
+           found = .FALSE.
+           
+    END SELECT    
+
+ END SUBROUTINE im_data_output_3d          
 !------------------------------------------------------------------------------!
 ! Description:
@@ -1397,10 +1721,5 @@
     CHARACTER (LEN=80) ::  line  !< string containing current line of file PARIN
 
-    
-    
-    NAMELIST /indoor_parameters/  building_type, dt_indoor,                           &
-                                  initial_indoor_temperature
-
-!    line = ' '
+    NAMELIST /indoor_parameters/  dt_indoor, initial_indoor_temperature
 
 !
@@ -1410,5 +1729,4 @@
     DO   WHILE ( INDEX( line, '&indoor_parameters' ) == 0 )
        READ ( 11, '(A)', END=10 )  line
-!    PRINT*, 'line: ', line
     ENDDO
     BACKSPACE ( 11 )
Index: /palm/trunk/SOURCE/module_interface.f90
===================================================================
--- /palm/trunk/SOURCE/module_interface.f90	(revision 3743)
+++ /palm/trunk/SOURCE/module_interface.f90	(revision 3744)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Add indoor model
 ! 
 ! Former revisions:
@@ -174,4 +174,7 @@
    USE indoor_model_mod,                                                       &
        ONLY:  im_parin,                                                        &
+              im_check_data_output,                                            &
+              im_check_parameters,                                             &
+              im_data_output_3d,                                               &
               im_init
 
@@ -497,4 +500,5 @@
    IF ( air_chemistry )        CALL chem_check_parameters
    IF ( gust_module_enabled )  CALL gust_check_parameters
+   IF ( indoor_model )         CALL im_check_parameters
    IF ( land_surface )         CALL lsm_check_parameters
    IF ( large_scale_forcing  .OR.  nudging )  CALL lsf_nudging_check_parameters ! ToDo: create single module switch
@@ -647,4 +651,8 @@
    ENDIF
 
+   IF ( unit == 'illegal' .AND. indoor_model ) THEN
+       CALL im_check_data_output( variable, unit )
+   ENDIF
+   
    IF ( unit == 'illegal'  .AND.  urban_surface                      &
         .AND.  variable(1:4) == 'usm_' )  THEN  ! ToDo: remove aditional conditions
@@ -1022,4 +1030,9 @@
    IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
       CALL gust_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
+      resorted = .TRUE.
+   ENDIF
+   
+   IF ( .NOT. found  .AND.  indoor_model )  THEN
+      CALL im_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
       resorted = .TRUE.
    ENDIF
Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3743)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3744)
@@ -20,5 +20,4 @@
 ! Current revisions:
 ! -----------------
-! 
 ! 
 ! Former revisions:
Index: /palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3743)
+++ /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3744)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Add indoor model
 ! 
 ! Former revisions:
@@ -660,6 +660,6 @@
                do2d_yz_time_count, dt_data_output_av, dt_do2d_xy, dt_do2d_xz,  &
                dt_do2d_yz, dt_do3d, dt_write_agent_data, mask_size,            &
-               do2d_xy_time_count,                                             &
-               do3d_time_count, domask_time_count, end_time, land_surface,     &
+               do2d_xy_time_count, do3d_time_count, domask_time_count,         &
+               end_time, indoor_model, land_surface,                           &
                mask_size_l, mask_i, mask_i_global, mask_j, mask_j_global,      &
                mask_k_global, mask_surface,                                    &
@@ -683,4 +683,7 @@
     USE kinds
 
+    USE indoor_model_mod,                                                      &
+        ONLY: im_define_netcdf_grid
+    
     USE land_surface_model_mod,                                                &
         ONLY: lsm_define_netcdf_grid, nzb_soil, nzt_soil, nzs, zs
@@ -1911,4 +1914,10 @@
                       CALL gust_define_netcdf_grid( do3d(av,i), found, grid_x, &
                                                     grid_y, grid_z )
+                   ENDIF
+!
+!--                Check for indoor model quantities                   
+                   IF ( .NOT. found .AND. indoor_model ) THEN 
+                      CALL im_define_netcdf_grid( do3d(av,i), found,           &
+                                                  grid_x, grid_x, grid_z )
                    ENDIF
 
